#include "taskFlyport.h"

#define LED2_ON           IOPut(D4Out , 1)   //OUT5 su Net - Led D2 su flyport
#define LED2_OFF          IOPut(D4Out , 0)
#define LED2_TOGGLE       IOPut(D4Out , IOGet(D4Out) ^ 0x01)


char ModbusTCP_M_RxData[100];
char debug[255];

int ModbusTCP_Master(char* rIP, char* rPort, int transactionId, int protocolId, int unitId,int function,int regaddress,int regsize,char *regvalue){
  TCP_SOCKET TcpID;
  DWORD      T0;
  char       txcmd[100];
  int        length;
  int        txsize;
  int        rxsize;
  int        i;
  
  TcpID = TCPClientOpen (rIP, rPort);
  T0 = TickGet();
  while((TcpID==INVALID_SOCKET)){
    if(TickGet() - T0 > 30*TICK_SECOND) return 0;
  }
  T0 = TickGet();
  while(TCPisConn(TcpID)==FALSE){
    if((TickGet()-T0)> 30*TICK_SECOND) return 0;
  }
  
  txcmd[0]  = (transactionId>>8) & 0x00FF;  //Transaction Identifier
  txcmd[1]  = (transactionId & 0x00FF);
  txcmd[2]  = ((protocolId>>8) & 0x00FF);   //Protocol Identifier
  txcmd[3]  = (protocolId & 0x00FF);
  txcmd[6]  = (unitId & 0x00FF);            //The Unit Identifier 
  txcmd[7]  = function;                     //Modbus Function Code
  txcmd[8]  = ((regaddress >>8) & 0x00FF);  //The Data Address of the first register requested
  txcmd[9]  = (regaddress & 0x00FF);
  //Read Holding Registers (http://www.simplymodbus.ca/FC03.htm)
  if(function==0x03){
    txcmd[10] = ((regsize>>8) & 0x00FF);
    txcmd[11] = (regsize & 0x00FF);
    length=4+2;
  //Read Input Registers (http://www.simplymodbus.ca/FC04.htm)
  } else if(function==0x04){
    txcmd[10] = ((regsize>>8) & 0x00FF);
    txcmd[11] = (regsize & 0x00FF);
    length=4+2;
  //Preset Single Register (http://www.simplymodbus.ca/FC06.htm)
  } else if(function==0x06){
    txcmd[10] = regvalue[0];
    txcmd[11] = regvalue[1];
    length=4+2;
  //Read Holding Registers (http://www.simplymodbus.ca/FC16.htm)
  } else if(function==0x10){
    txcmd[10] = ((regsize>>8) & 0x00FF);
    txcmd[11] = (regsize & 0x00FF);
    txcmd[12] = ((regsize *2) & 0x00FF);
    memcpy(txcmd+13,regvalue, txcmd[12]);
    length=4+3+txcmd[12];
  }
  txsize=6+length;
  txcmd[4]=((length >>8) & 0x00FF);  // Message Length  
  txcmd[5]=(length & 0x00FF);
  txsize=6+length;
  TCPWrite (TcpID, txcmd, txsize);
  T0=TickGet();
  rxsize=0;
  do {
    rxsize = TCPRxLen(TcpID); 
    if(rxsize>0){
      if(rxsize>sizeof(ModbusTCP_M_RxData)) rxsize=sizeof(ModbusTCP_M_RxData); 
      T0=TickGet();
      TCPRead (TcpID, ModbusTCP_M_RxData, rxsize);
      break;
    }
    if((TickGet()-T0) > 30*TICK_SECOND) {
      TCPClientClose(TcpID);
      return 0;
    }
  } while(TCPisConn(TcpID));
  TCPClientClose(TcpID);
  if(rxsize>6){ //check rx header
    for (i=0; i<7; i++){
    if(i==4 || i==5) continue;
      if((unsigned char)txcmd[i] != (unsigned char)ModbusTCP_M_RxData[i]){
        UARTWrite(1,debug);
        return -1;
      }
    }
  }
  return rxsize;
}

void FlyportTask() {
  char writevalue[100];
  int ret;
  int i;
  
  UARTWrite(1,"Configurazione di UFFICIO\r\n" ); 
  WFSetParam(MY_IP_ADDR,    "192.168.9.138"   );
  WFSetParam(SUBNET_MASK,   "255.255.255.0"   );
  WFSetParam(PRIMARY_DNS,   "195.110.128.1"   );
  WFSetParam(SECONDARY_DNS, "212.48.4.11"     );
  WFSetParam(MY_GATEWAY,    "192.168.9.1"     );
  WFSetParam(DHCP_ENABLE,   DISABLED          );
  WFSetParam(SSID_NAME,     "www.areasx.com"  );
  WFSetParam(NETWORK_TYPE,  INFRASTRUCTURE    );
  WFSetSecurity(WF_SECURITY_WPA2_WITH_PASS_PHRASE,"xxxxxxxxxx",10,0);
  WFConnect(WF_CUSTOM);
  
  while (WFStatus != CONNECTED);
  UARTWrite(1,"Flyport connesso alla rete Wi-Fi\r\n");
  
  while(1) {
    UARTWrite(1,"*******************Get Input\r\n");
    ret=ModbusTCP_Master("192.168.9.135", "502", 0x00, 0x00, 0x01,0x03,0x00,0x01,0x0);
    if(ret>0){
      for (i=0; i<8; i++){
        sprintf(debug, "Input %d [", i);
        if(((ModbusTCP_M_RxData[10]>>i) && 0x01)==0x01)
          strcat(debug,"X");
        else 
          strcat(debug," ");
        strcat(debug,"]\r\n");
        UARTWrite(1,debug);
      }
      
    } else {
      sprintf(debug, "Connessione fallita \r\n%d\r\n" , ret);
      UARTWrite(1,debug);
    }	

    UARTWrite(1,"!!!!!!!!!!!!!!!!!!!Get Output\r\n");
    ret=ModbusTCP_Master("192.168.9.135", "502", 0x00, 0x00, 0x01,0x03,0x08,0x01,0x0);
    if(ret>0){
    /*
      UARTWrite(1,"Comando ModBus OK!!\r\nRisposta:\r\n");
    for (i=0; i<ret; i++){
        sprintf(debug, "RX %d -> 0x%x\r\n", i, (unsigned char)ModbusTCP_M_RxData[i]);
        UARTWrite(1,debug);
      }
    */
      for (i=0; i<8; i++){
        sprintf(debug, "Output %d [", i);
        if(((ModbusTCP_M_RxData[10]>>i) && 0x01)==0x01)
          strcat(debug,"X");
        else 
          strcat(debug," ");
        strcat(debug,"]\r\n");
        UARTWrite(1,debug);
      }
      
    } else {
      sprintf(debug, "Connessione fallita \r\n%d\r\n" , ret);
      UARTWrite(1,debug);
    }




    UARTWrite(1,"!!!!!!!!!!!!!!!!!!!Set GPIO\r\n");
    writevalue[0]=ModbusTCP_M_RxData[9];
    writevalue[1]=ModbusTCP_M_RxData[10]^0x01;
    ret=ModbusTCP_Master("192.168.9.135", "502", 0x00, 0x00, 0x01,0x10,0x08,0x01,writevalue);
    if(ret>0){
    /*
      UARTWrite(1,"Comando ModBus OK!!\r\nRisposta:\r\n");
      for (i=0; i<ret; i++){
        sprintf(debug, "RX %d -> 0x%x\r\n", i, (unsigned char)ModbusTCP_M_RxData[i]);
        UARTWrite(1,debug);
      }
    */
    } else {
      sprintf(debug, "Connessione fallita \r\n%d\r\n" , ret);
      UARTWrite(1,debug);
    }
    
    LED2_ON;
    vTaskDelay(10);
    LED2_OFF;
    vTaskDelay(500);
    vTaskDelay(500);
  }
}
